Bug 1689542 - Review Request: rubygem-tomlrb - TOML parser based on racc
Summary: Review Request: rubygem-tomlrb - TOML parser based on racc
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-16 15:32 UTC by Fabio Valentini
Modified: 2019-03-29 19:18 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-29 02:58:55 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Fabio Valentini 2019-03-16 15:32:18 UTC
Spec URL: https://decathorpe.fedorapeople.org/packages/rubygem-tomlrb.spec
SRPM URL: https://decathorpe.fedorapeople.org/packages/rubygem-tomlrb-1.2.8-1.fc29.src.rpm

Description:
A racc based toml parser.

Fedora Account System Username: decathorpe

koji scratch build for rawhide: https://koji.fedoraproject.org/koji/taskinfo?taskID=33537355

Comment 1 Vít Ondruch 2019-03-18 12:10:12 UTC
Hi,

Two remarks:

1) The test suite should be executed.
2) It would be nice if the parsers can be regenerated from source code.

Comment 2 Vít Ondruch 2019-03-18 12:14:08 UTC
(In reply to Vít Ondruch from comment #1)
> 2) It would be nice if the parsers can be regenerated from source code.

And the parser grammar is not needed to ship.

Comment 3 Fabio Valentini 2019-03-18 12:16:59 UTC
Thanks for looking at this!

> 1) The test suite should be executed.

That's rather cumbersome, since neither tests nor test data are shipped with the .gem file.
I would have to generate those separately from the GitHub repository.
Is that really necessary?

> 2) It would be nice if the parsers can be regenerated from source code.

That I can do. The next version I submit here will contain this change.

> And the parser grammar is not needed to ship.

I will %exclude that file from the %files list.

Comment 4 Vít Ondruch 2019-03-18 13:05:57 UTC
(In reply to Fabio Valentini from comment #3)
> Thanks for looking at this!
> 
> > 1) The test suite should be executed.
> 
> That's rather cumbersome, since neither tests nor test data are shipped with
> the .gem file.

That is nothing exceptional. Guidelines mention this situation.

> I would have to generate those separately from the GitHub repository.
> Is that really necessary?

a) There is no compiler, which would catch basic issues.
b) There is no other way to tell if the package works or not. I would like to peek into Koschei and see if it still works. That is not possible without tests.

Comment 5 Fabio Valentini 2019-03-18 19:39:12 UTC
> That is nothing exceptional. Guidelines mention this situation.

Right. I'll work on it.

I'll have the next version ready later today or tomorrow.

Comment 6 Fabio Valentini 2019-03-18 20:07:24 UTC
- Regenerated the parser from the grammar
- Included and enabled the test suite
- Removed the grammar file from the installed files

Spec URL: https://decathorpe.fedorapeople.org/packages/rubygem-tomlrb.spec
SRPM URL: https://decathorpe.fedorapeople.org/packages/rubygem-tomlrb-1.2.8-2.fc29.src.rpm

Comment 7 Robert-André Mauchin 🐧 2019-03-18 20:12:24 UTC
Tests run fine.
Parser sources regenerated. Parser grammar removed.

Package approved.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains Requires: ruby(release).


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 1 files have unknown license. Detailed
     output of licensecheck in /home/bob/packaging/review/rubygem-
     tomlrb/review-rubygem-tomlrb/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[-]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     tomlrb
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.
[x]: gems should not require rubygems package
[x]: Specfile should use macros from rubygem-devel package.
[x]: Test suite should not be run by rake.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-tomlrb-1.2.8-2.fc31.noarch.rpm
          rubygem-tomlrb-doc-1.2.8-2.fc31.noarch.rpm
          rubygem-tomlrb-1.2.8-2.fc31.src.rpm
rubygem-tomlrb.noarch: W: spelling-error Summary(en_US) racc -> race, racy, rack
rubygem-tomlrb.noarch: W: spelling-error %description -l en_US racc -> race, racy, rack
rubygem-tomlrb.noarch: W: spelling-error %description -l en_US toml -> tom, tome, toms
rubygem-tomlrb.noarch: W: no-documentation
rubygem-tomlrb.src: W: spelling-error Summary(en_US) racc -> race, racy, rack
rubygem-tomlrb.src: W: spelling-error %description -l en_US racc -> race, racy, rack
rubygem-tomlrb.src: W: spelling-error %description -l en_US toml -> tom, tome, toms
rubygem-tomlrb.src: W: invalid-url Source1: tomlrb-1.2.8-test.tar.gz
3 packages and 0 specfiles checked; 0 errors, 8 warnings.

Comment 8 Fabio Valentini 2019-03-18 20:24:45 UTC
Thanks for the review!

What's the issue "Package contains Requires: ruby(release)." about?
That's only in the BuildRequires, where it was automatically added by gem2rpm.
It's not present in the built package's Requires.

Comment 9 Robert-André Mauchin 🐧 2019-03-18 20:45:09 UTC
It's a check for this:

Each Ruby package MUST indicate it depends on a Ruby interpreter (this does not apply to RubyGems). Use ruby(release) virtual requirement to achieve that:
    Requires: ruby(release)

https://docs.fedoraproject.org/en-US/packaging-guidelines/Ruby/#_ruby_compatibility


It doesn't not apply to rubygems package so no worry. I haven't seen a non-rubygems Ruby package yet though.

Comment 11 Vít Ondruch 2019-03-19 08:08:53 UTC
Good work! Thx. Just three remarks:

* The first %setup call is useless IMO.
* I prefer to use -b1 to expand the test suite and later copy/link the test suite on the proper place just in %check section. This is just me being cautious from the experience because it makes harder to accidentally include the test suite in the regenerated gem.

> - Regenerated the parser from the grammar

* I prefer to explicitly delete the original generated grammar file, just to be really sure.

Comment 12 Gwyn Ciesla 2019-03-19 14:01:13 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/rubygem-tomlrb

Comment 13 Fabio Valentini 2019-03-19 15:39:15 UTC
> Good work! Thx. Just three remarks:

I've addressed the first two points:
https://github.com/decathorpe/rpmbuild-staging/commit/9749338

Those changes will be part of the initial import that I'll be doing now.
I also checked and the test files aren't included in the built package.

Thanks for your help!

Comment 14 Fedora Update System 2019-03-19 15:57:46 UTC
rubygem-tomlrb-1.2.8-3.fc30 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-f3b20448c8

Comment 15 Fedora Update System 2019-03-19 15:58:39 UTC
rubygem-tomlrb-1.2.8-3.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-062a95fb09

Comment 16 Fedora Update System 2019-03-20 22:02:13 UTC
rubygem-tomlrb-1.2.8-3.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-062a95fb09

Comment 17 Fedora Update System 2019-03-21 19:11:46 UTC
rubygem-tomlrb-1.2.8-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-f3b20448c8

Comment 18 Fedora Update System 2019-03-29 02:58:55 UTC
rubygem-tomlrb-1.2.8-3.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2019-03-29 19:18:20 UTC
rubygem-tomlrb-1.2.8-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.